#!/opt/optD2cc_bin_links/perl
#
# perl script used for makefile
#
# ==========================================================================
#
sub usage {
    die <<"EndUsage";
usage: $0 [-hm]  
Process the HTML file to generate postscript.
Display Options:
     -h  Help -- just display this message and quit.
	  -m  generate the makefile
     -t  just display the nexted files.

EndUsage
}
#
# ==========================================================================
use IO::File;    #  new $handle =  IO::File


require "getopts.pl";
&Getopts('mh');
if ($@ || $opt_h) { &usage; }

$thistime   = time;
# Get the current date-time stamp
$ctime     = localtime($thistime);
print "xnd_mak.pl    $ctime\n";

# open "xnd_pl.res"
chomp($cur_dir = `pwd`);

opendir(DIR, $cur_dir) || die "can't opendir $cur_dir : $!";
@contents= grep { m/^xnd[^\.].*[hc]$/ } readdir(DIR);
closedir(DIR);
@source = grep ( m/\.c$/, @contents);
@header = grep ( m/\.h$/, @contents);
@contents = ();
print  $cur_dir, " contains ", $#source, " c source files, ", $#header, " h header files\n\n";

my (@href) = ();
$i=0;
foreach $hname (@header) {  $href[$i++] = 0;	}
my (@cross_ref) = ();
$i=0;
foreach $cname (@source) {
  foreach $hname (@header) {  $cross_ref[$i++] = 0;   }
    }
my (@make_ref) = ();
$i=0;
foreach $cname (@source) {  $make_ref[$i++] = 0;   }
my (@make_objs) = ();
    
my (@ifdef_ok) = ();
my ($cfile_no) = 0;
$c_lines=0;
$h_lines=0;

$in_comments = 0;

my ($h_make) = 0;
 
   $makename = ">makefile.tmp";
	open ( FILE_M, $makename ) || warn " error opening $makename\n";
   &ini_makefile();

$dbg=0;
#==========================================================================

foreach $name (@source)
{   ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)
                = stat($name);
$ma = localtime($mtime);
	print " $name           ($ma)   $size\n";
	$level = 0;
   $in_comments = 0;
	@def_symb = ();
	@inc_head = ();
	@ifdef_ok = ();
	@cur_h = ();
	open ( FILE_C, $name ) || warn " error opening $name\n";
   $lineno = 0;
	$o_name = $name;
	push(@ifdef_ok, 1);
	$o_name =~ s/.c$/.o/g ;
	print FILE_M  "$o_name : \$(S_DIR)$name ";
   $h_make = 1;
	foreach $oref (@make_objs) {
	   if ( $oref eq $o_name ) {  $make_ref[$cfile_no]++; }
		}
	while ( $line = <FILE_C> ) {    # read a line at a time.
        $lineno++;
        $c_lines++;
		  chomp($line);
		  &do_line($line, $lineno);         }
      close (FILE_C);
	   print FILE_M  "\n\t(cd \$(S_DIR);\$(CC) \$(CFLAGS) -c -o \$(O_DIR)$o_name $name)\n";
      &flush_makefile();
   if ( $opt_s ){ foreach $symb (@def_symb) { print $symb, " \n"; } }
   if ( $opt_i ){ foreach $symb (@def_symb) { print $symb, " \n"; } }
   $cfile_no++;
	}
	
&end_makefile(); 

print "\n included headers\n";

foreach $name (@header)
{   ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,$blksize,$blocks)
                = stat($name);
$ma = localtime($mtime);
	print " $name      ($ma)   $size ";
   my ($h) = get_hnum($name);
	print "   $href[$h]\n";
	open ( FILE_H, $name ) || warn " error opening $name\n";
	while ( $line = <FILE_H> ) {    # read a line at a time.
         $h_lines++;
         }
      close (FILE_H);
     }
print "\ncross_ref  (make)  headers\n";
$i=0;
$m=0;
foreach $name (@source)
{  printf("\n%12s (%d) ", $name, $make_ref[$m++]);
   foreach $hname (@header)
   {   print " $cross_ref[$i++]";
       }
	}


print "\n\n $c_lines c + $h_lines h = ",($c_lines+$h_lines)," lines\n";
if ($opt_m) { 
	print "\nmakefile has been changed (opt_m set)\n";
	} else {
	print "\nmakefile has not been changed (opt_m not set), makefile.tmp is updated\n";
   }	  
# ==========================================================================

# do_line(line of text data, line number, filename);
#   process a line of text.  
sub do_line ($$$) {
my($line, $lineno) = @_;
die if ($ifdef_ok[$#ifdef_ok] == -1 );

if ( $in_comments == 0 ) { 
   if ( $line =~ m:(.*)/\*(.*):  ) {
      my ($valid_str) = $1;
		my ($comments)= $2;
		&do_line ( $valid_str, $lineno );
		$in_comments = 1;
		&do_line( $comments);
		return;
	} } else {
	if ( $line =~ m:(.*)\*/(.*):    ) {
		$in_comments = 0;
      &do_line( $2, $lineno);
		return;
	} }

if (  $in_comments == 0 && $ifdef_ok[$#ifdef_ok] == 1 ) {
   if ( $line =~ m:(#define\s+)(\w+)(.*):  ) {
     push(@def_symb, $2);
	  return;
     }	
   if ( $line =~ m:(#undef\s+)(\w+)(.*):  ) {
	  $i = &get_symb($2);
	  if ( $i >= 0  ) { $def_symb[$i] = ""; }
	  return;
     }	
   if ( $line =~ m:(#include\s+")(.*)":  ) {
#   print "INCLUDE ", $2, "\n";#
     push(@inc_head, $2);
	  &process_hfile($2);
	  return;
     }	
	}  	
   if ( $line =~ m:(#ifdef\s+)(\w+)(.*):  ) {
#     print "IFDEF  $2  "; 
	  if ( $ifdef_ok[$#ifdef_ok] == 1 ) {
	     my ($i) =&get_symb($2);
		  if ( $i == -1  ) { push(@ifdef_ok, 0);   }
		  else  { push(@ifdef_ok, 1);  }
		  }  
	  else  { push(@ifdef_ok, 2); }
	  return;
     }	
  if ( $line =~ m:(#ifndef\s+)(\w+)(.*):  ) {
#     print "IFNDEF  $2 \n";
	  if ( $ifdef_ok[$#ifdef_ok] == 1 ) {
	     if ( &get_symb($2) >= 0  ) { push(@ifdef_ok, 0); }
		  else { push(@ifdef_ok, 1); }
		  }  
	  else  { push(@ifdef_ok, 2); }
	  return;
     }
  if ( $line =~ m:(#if\s*\(\s*)(\w+\s*\)\s*)(.*):  ) {
#     print "IF ( $2 )\n";
	  if ( $ifdef_ok[$#ifdef_ok] == 1 ) {
	     warn " if() not evaluated\n";
		  if ( &get_symb($2) >= 0  ) { push(@ifdef_ok, 0); }
		  else { push(@ifdef_ok, 1); }
		  }  
	  else  { push(@ifdef_ok, 2); }
	  return;
     }
if ( $line =~ m:(#else\s*)(\w*)(.*):  ) {
#	  print "ELSE  $lineno $line \n";
	  if ( $ifdef_ok[$#ifdef_ok -1] == -1 ) { return; }
	  if ( pop(@ifdef_ok) == 1) {
	     push(@ifdef_ok, 0 ); 
		  } else {
	     push(@ifdef_ok, 1 ); 
		  }
	  return;
     }	
if ( $line =~ m:(#endif\s*)(\w*)(.*):  ) {
#	  print "ENDIF  $lineno $line \n";
	  pop(@ifdef_ok);
	  return;
     }	
  }
	  
# ==========================================================================
	  
sub process_hfile($$$) {
   my($name) = @_;
   $level++;
	for ($i=0; $i <$level; $i++) { print "    "; }
	print "$name\n";
	  if (($h_make++ % 3 ) == 0) { print FILE_M "\\\n            "; }
	  print FILE_M  "\$(S_DIR)$name ";	
   my ($h) = get_hnum($2);
	my ($old_h) = $cur_h;
	push (@cur_h, $h);
	$href[$h]++;
   $cross_ref[$cfile_no * @header + $h] = 1;
   my $handle = new IO::File;
	open ( $handle, $name ) || warn " error opening h file $name\n";
   $lineno = 0;
	while ( $line = <$handle> ) {    # read a line at a time.   
        $lineno++;
		  chomp($line);  
		  &do_line($line, $lineno);
    }	
   close ($handle);
	pop (@cur_h);
   $level--;
 }
	  
# ==========================================================================
	  
sub get_symb($$$) {
   my ($symb) = @_;
   my ($i) = 0;
	if ( $#def_symb == -1 ) { return -1; }
	for ($i=0; $i < @def_symb; $i++) {
	  if ( $symb eq $def_symb[$i]  ) { return $i; }
		}
	return -1;
	}  
# ==========================================================================
	  
sub get_hnum($$$) {
   my ($name) = @_;
   my ($i) = 0;
	for ($i=0; $i < @header; $i++) { 
	  if ( $name eq $header[$i]  ) { return $i; }
		}
	warn " header file $name not in initial list\n";
	return -1;
	}  
	  
# ==========================================================================
#  makefile procedures	  
# ==========================================================================
sub ini_makefile() {
   print FILE_M <<"EOF_IniMak";
# XND/makefile
#
# this is the current makefile, other files
# makefile.xxx are examples which have not been updated
# 
############################################################
#
# Directories ( location of the executable )
DEST= /usr/local/bin
# Directories ( html documentation : local site server)
HTMLDIR= /usr/local/www/onsite_only/xnd
# sources directory and object relative directory
S_DIR = ./
O_DIR = ./
#
#  if config.mak does not exist 
#  any other file in mak folder can be copied into config.mak
#  it will just be used to allow configuration at the first make
#  and set not too bad options
#
include config.mak
#
############################################################
############################################################
#
PROGRAM= xnd
#
#
# lines for use with ar
OBJS=     xnd_main.o xnd_loop.o xnd_sng.o xnd_mini.o
LIBS =    xnd_clib.a xnd_mlib.a xnd_rlib.a xnd_plib.a xnd_wlib.a xnd_ulib.a
O_RLIB =  xnd_rd.o xnd_r11.o xnd_r12.o xnd_rexp.o xnd_rex1.o xnd_rex2.o xnd_rex3.o \\
          xnd_rpha.o xnd_rcry.o xnd_rato.o xnd_rsym.o xnd_rdif.o
O_PLIB =  xnd_pro.o xnd_prvo.o xnd_prps.o xnd_prga.o xnd_prlo.o xnd_pras.o xnd_prac.o  \\
          xnd_cplx.o
O_ULIB =  xnd_var.o xnd_vio.o xnd_keys.o xnd_use.o xnd_sig.o xnd_swap.o xnd_mat.o \\
          xnd_met.o xnd_num.o xnd_sets.o xnd_atom.o xnd_sym.o 
O_MLIB =  xnd_ips.o xnd_mod.o xnd_inc.o xnd_moco.o xnd_mag.o xnd_sym4.o xnd_com.o
O_CLIB =  xnd_cal.o xnd_der.o xnd_brg.o xnd_hkl.o xnd_bac.o xnd_blk.o xnd_amo.o \\
          xnd_unc.o xnd_pen.o xnd_dif.o xnd_cor.o xnd_deb.o
O_WLIB =  xnd_lst.o xnd_new.o xnd_cif.o 
#
MAKS = mak/hp-ux.ansi mak/hp-ux.kk mak/sunOs.ansi mak/sunOs.kk \\
       mak/aix.ansi mak/unknown mak/linux.ansi mak/cygW32.ansi
#
############################################################
#
\$(PROGRAM) : config.mak \$(OBJS) \$(LIBS) xnd_ref.sh
	echo "make options have been set using mak/\$(KERNEL)"
	./xnd_ref.sh
	\$(CC) \$(CFLAGS) -DKERNEL='"\$(KERNEL)"' -DHOST='"\$(HOST)"' -o \$@ \$(S_DIR)xnd_ref.c \\
	\$(OBJS) \\
	\$(LIBS) -lm
############################################################
# to allow configuration
config.mak : \$(MAKS) makefile config.sh
	./config.sh
	echo "please restart make, if it fails, just type make"
#	make
#  auto restart loops on some system, removed
############################################################
# ar or ar+ranlib
xnd_rlib.a : \$(O_RLIB)
	ar r xnd_rlib.a \$(O_RLIB)
xnd_plib.a : \$(O_PLIB)
	ar r xnd_plib.a \$(O_PLIB)
xnd_ulib.a : \$(O_ULIB)
	ar r xnd_ulib.a \$(O_ULIB)
xnd_mlib.a : \$(O_MLIB)
	ar r xnd_mlib.a \$(O_MLIB)
xnd_clib.a : \$(O_CLIB)
	ar r xnd_clib.a \$(O_CLIB)
xnd_wlib.a : \$(O_WLIB)
	ar r xnd_wlib.a \$(O_WLIB)
############################################################
all    :
	-rm config.mak
	-rm \$(PROGRAM)
	-rm \$(OBJS) 
	-rm \$(O_RLIB) \$(O_PLIB) \$(O_ULIB) \$(O_WLIB) \$(O_CLIB) \$(O_MLIB)
	make
############################################################
public :
	cp -f xnd \$(DEST)
	cp -f xnd_sym.d \$(DEST)
	cp -f xnd_dif.d \$(DEST)
	cp -f html/xnd*.html   \$(HTMLDIR)
	cp -f html/xnd_ps.tar.gz  \$(HTMLDIR)
	cp -f html/ps/xnd*.ps  \$(HTMLDIR)/ps
############################################################
# these two are only for private use
############################################################
touch  :
	touch xnd_ref.tim
############################################################
tar : xnd.tar
	xnd.tar  \$(KERNEL)
############################################################
############################################################
# start of generated dependencies
EOF_IniMak
close FILE_M;
# prepare the hash of refered _files
   $makename = "makefile.tmp";
	open ( FILE_M, $makename ) || warn " error opening $makename\n";
	my (@array) = ();
	while ( $line = <FILE_M> ) {    # read a line at a time.
	   @array = ();
	   chomp($line);
      while ( $line =~ s:\\$: :  ) {
		  $newline = <FILE_M> ;
		  $line = join(" ", $line, $newline );
		  chomp($line);
        }
		if ( $line =~ m:(^OBJS\s*=)(.*):  ) {
           @array = split(/[ ]+/, $2);
			  foreach $oname (@array) { push @make_objs, $oname; }
             } else {
      if ( $line =~ m:(^O_.LIB\s*=)(.*):  ) {
           @array = split(/[ ]+/, $2);
			  foreach $oname (@array) { push @make_objs, $oname; }
         }   }
      }
  close FILE_M;
  $makename = ">>makefile.tmp";
	&flush_makefile(); 
   }	  
# ==========================================================================
sub flush_makefile() {
  close FILE_M;
  open ( FILE_M, $makename ) || warn " error append to $makename\n";
  }
# ==========================================================================
sub end_makefile() {
   &flush_makefile();
	print FILE_M <<"EOF_EndMak";
############################################################
# end of generated dependencies
############################################################
EOF_EndMak
close FILE_M;
if ($opt_m) { 
   system ( "cp makefile.tmp makefile");
   print   "\ncp makefile.tmp makefile\n" ;
	} else {
	print "makefile has not been changed (opt_m not set), makefile.tmp is updated\n";
   }	  
 }	  
# ==========================================================================
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
	  
